---
layout: default
title: Agile delivery
description: "Agile delivery is an iterative approach to software delivery in which teams build software incrementally at the beginning of a project rather than ship it at once upon completion."
suppress_header: true
extra_css:
  - devops.css
  - agile-delivery.css
extra_js:
  - libs/on-scroll.js
  - in-page-nav.js
  - all-clickable.js
canonical_path: "/topics/agile-delivery/"
---
.blank-header
  = image_tag "/images/home/icons-pattern-left.svg", class: "image-border image-border-left", alt: "Gitlab hero border pattern left svg"
  = image_tag "/images/home/icons-pattern-right.svg", class: "image-border image-border-right", alt: "Gitlab hero border pattern right svg"
  .header-content
    = image_tag "/images/agile/agile.svg", class: "hero-image-huge", alt: "GitLab agile graphic"
    %h1 Agile delivery
    %a.btn.cta-btn.orange.devops-cta{ href: "https://learn.gitlab.com/c/201906-whitepaper-re?x=9tzwq4&utm_medium=other&utm_source=webpage&utm_campaign=betterproductsfaster" } Learn how to accelerate delivery

.wrapper.wrapper--large-fonts
  #content.devops-content.u-margin-top-md
    .wrapper.container.js-in-page-nav-group{role: "main"}
      .row.u-margin-top-lg.js-in-page-nav-section#what-is-agile-delivery
        .col-md-10.col-md-offset-1
          %h2.u-text-brand What is Agile delivery?

          %p Agile is one of the most important and transformative methodologies introduced to the software engineering discipline in recent decades, helping software teams efficiently create customer-centric products.

          %blockquote.blockquote-alt.cicd-blockquote
            %b Agile delivery
            is an iterative approach to software delivery in which teams build software incrementally at the beginning of a project rather than ship it at once upon completion.

          %p Agile development means taking iterative, incremental, and lean approaches to streamline and accelerate the delivery of projects.

      .row.u-margin-top-lg.js-in-page-nav-section#why-embrace-agile-delivery
        .col-md-10.col-md-offset-1
          %h2.u-text-brand Why embrace Agile delivery?

          %p The demand for faster software development is universal, and Agile delivery meets both customer and business needs.

          %p Organizations that adopt Agile delivery practices can gain a competitive edge in a fast changing market. Businesses that empower teams to use Agile development practices satisfy discerning customers and adapt to new technologies, helping them to develop the products that set the standard for industries.

          %p It's not just businesses that benefit from Agile delivery. Customers have more substantive experiences with organizations when their needs are met and their feedback makes a difference in product development. Customers appreciate when their input and expectations help shape an organization’s releases.


      .row.u-margin-top-lg.js-in-page-nav-section#benefits-of-agile
        .cta-featured-grid
          .row.u-margin-bottom-md
            .col-md-10.col-md-offset-1
              %h2.u-text-brand Benefits of Agile delivery
              .featured-icons.text-center
                .featured-icon
                  = partial "/images/icons/scale.svg"
                  %p.number Speed to market
                  %p.description Faster time-to-market enables quicker customer feedback and higher customer satisfaction.
                .featured-icon
                  = partial "/images/icons/computer-test2.svg"
                  %p.number Higher quality
                  %p.description Since testing is integrated throughout the lifecycle, teams have early sight into quality issues.
                .featured-icon
                  = partial "/images/icons/visibility.svg"
                  %p.number Transparency
                  %p.description Teams are involved throughout a project — from planning and prioritizing to building and deploying.


      .row.u-margin-top-sm.js-in-page-nav-section#agile-delivery-basics
        .col-md-10.col-md-offset-1
          %h2.u-text-brand Agile delivery basics

          %p Getting started with Agile means becoming acquainted with the most common methodologies and characteristics.

          .media.u-margin-top-sm.u-margin-bottom-md.has-shadowed-svg
            .media-left.media-middle.u-padding-right-sm
              .media-object{ style: "width: 80px; height: 80px" }
                = image_tag "/images/icons/scrum.svg"

            .media-body.media-middle
              %h3.u-margin-top-0 Scrum

              %p.u-margin-bottom-0 Scrum, often synonymous with Agile, is an approach that emphasizes continuous improvement, self organization, and experience-based learning. By utilizing user stories, tasks, backlogs, and extensions, teams have a structured model to carry them across a software development lifecycle. Teams that use a Scrum approach to development are likely to be committed, respectful, and focused.

          .media.u-margin-top-sm.u-margin-bottom-md.has-shadowed-svg
            .media-left.media-middle.u-padding-right-sm
              .media-object{ style: "width: 80px; height: 80px;" }
                = image_tag "/images/icons/kanban.svg"
            .media-body.media-middle
              %h3.u-margin-top-0 Kanban

              %p.u-margin-bottom-0 Teams that use a Kanban framework favor transparency and communication. Tasks are organized using Kanban cards on a board to enable end-to-end visibility throughout production. Three practices guide Kanban: visualize work, limit work in progress, manage flow. Teams that use a Kanban framework are collaborative, transparent, balanced, and customer focused.

          .media.u-margin-top-sm.u-margin-bottom-md.has-shadowed-svg
            .media-left.media-middle.u-padding-right-sm
              .media-object{ style: "width: 80px; height: 80px;" }
                = image_tag "/images/icons/agile.svg"
            .media-body.media-middle
              %h3.u-margin-top-0 Agile mindset

              %p.u-margin-bottom-0 An Agile mindset means viewing setbacks as learning opportunities, embracing iteration, collaboration, and change, and focusing on delivering value. With an Agile mindset, teams can adjust to changing market needs, respond to customer feedback, and deliver business value. Adopting a new perspective can positively change a team’s culture, since the shift permits innovation without fear, collaboration with ease, and delivery without roadblocks.

          = image_tag "/images/agile/agile-ci-cd.svg", alt: "Agile diagram"


      .row.u-margin-top-lg.js-in-page-nav-section#resources
        .col-md-10.col-md-offset-1

          %h2.u-text-brand Resources

          %p Here’s a list of resources on Agile that we find to be particularly helpful in understanding Agile and implementation. We would love to get your recommendations on books, blogs, videos, podcasts and other resources that tell a great Agile story or offer valuable insight on the definition or implementation of the practice.

          %p
            Please share your favorites with us by tweeting us
            %a{:href => 'https://twitter.com/gitlab'} @GitLab!

          .feature-group.feature-group--alt.u-margin-top-lg.u-padding-top-0.u-padding-bottom-0
            .row.flex-row
              .col-md-4.col-lg-4.u-margin-bottom-sm
                .feature.js-all-clickable
                  .feature-media
                    = image_tag "/images/agile/feature-thumb-how-to-use-gitlab.jpg"
                  .feature-body
                    %h3.feature-title How to use GitLab for Agile software development
                    %p.feature-description How Agile artifacts map to GitLab features and how an Agile iteration looks in GitLab.
                    = link_to "Read", "/blog/2018/03/05/gitlab-for-agile-software-development/", class: "feature-more"

              .col-md-4.col-lg-4.u-margin-bottom-sm
                .feature.js-all-clickable
                  .feature-media
                    = image_tag "/images/agile/feature-thumb-what-is-agile-mindset.jpg"
                  .feature-body
                    %h3.feature-title What is an Agile mindset?
                    %p.feature-description Learn how embracing change can help you speed up software delivery.
                    = link_to "Read", "/blog/2019/06/13/agile-mindset/", class: "feature-more"

              .col-md-4.col-lg-4.u-margin-bottom-sm
                .feature.js-all-clickable
                  .feature-media
                    = image_tag "/images/agile/feature-thumb-4-ways-to-use-gitlab.jpg"
                  .feature-body
                    %h3.feature-title 4 ways to use GitLab Issue Boards
                    %p.feature-description By leveraging the power of labels, GitLab Issue Boards can be easily customized to support any workflow. Here are four examples.
                    = link_to "Read", "/blog/2018/08/02/4-ways-to-use-gitlab-issue-boards/", class: "feature-more"

              .col-md-4.col-lg-4.u-margin-bottom-sm
                .feature.js-all-clickable
                  .feature-media
                    = image_tag "/images/agile/feature-thumb-scoped-labels.jpg"
                  .feature-body
                    %h3.feature-title Scoped Labels with GitLab
                    %p.feature-description A small change with a huge impact: Scoped Labels can help teams customize their workflow and speed up delivery.
                    = link_to "Read", "/blog/2019/06/20/issue-labels-can-now-be-scoped/", class: "feature-more"

              .col-md-4.col-lg-4.u-margin-bottom-sm
                .feature.js-all-clickable
                  .feature-media
                    = image_tag "/images/agile/feature-thumb-5-ways-to-stay-agile.jpg"
                  .feature-body
                    %h3.feature-title 5 ways to stay agile in a growing organization
                    %p.feature-description Some of the GitLab Manage team have a conversation about staying agile as a company grows.
                    = link_to "Read", "/blog/2019/06/10/manage-conversation-staying-agile/", class: "feature-more"

              .col-md-4.col-lg-4.u-margin-bottom-sm
                .feature.js-all-clickable
                  .feature-media
                    = image_tag "/images/agile/feature-thumb-pairing-sessions.jpg"
                  .feature-body
                    %h3.feature-title Agile for developers: pairing sessions
                    %p.feature-description Pairing with a teammate can increase delivery. Here's a look at the pros and cons.
                    = link_to "Read", "/blog/2019/08/20/agile-pairing-sessions/", class: "feature-more"


        .col-md-10.col-md-offset-1

          .resource-block.resource-block--videos
            %h3.block-title Videos

            %ul.resource-list.list-unstyled
              %li.resource-list-item
                %h4.resource-title
                  %a{ href: "https://www.youtube.com/watch?v=wmtZKC8m2ew" } Agile project management
              %li.resource-list-item
                %h4.resource-title
                  %a{ href: "https://www.youtube.com/watch?v=VR2r1TJCDew" } Setting up Agile groups and teams
              %li.resource-list-item
                %h4.resource-title
                  %a{ href: "https://www.youtube.com/watch?v=PmFFlTH2DQk" } Scaled Agile Framework (SAFe) with GitLab


          .resource-block.resource-block--podcasts
            %h3.block-title Webpages

            %ul.resource-list.list-unstyled
              %li.resource-list-item
                %h4.resource-title
                  = link_to "Agile planning", "/solutions/agile-delivery/"

              %li.resource-list-item
                %h4.resource-title
                  = link_to "Scaled Agile and GitLab", "/solutions/agile-delivery/scaled-agile/"

              %li.resource-list-item
                %h4.resource-title
                  = link_to "Accelerating software delivery", "/solutions/faster-software-delivery/"


          .resource-block.resource-block--casestudies
            %h3.block-title Case studies

            %ul.resource-list.list-unstyled
              %li.resource-list-item
                %h4.resource-title
                  = link_to "Axway was able to achieve hourly deployments with GitLab CI/CD", "/customers/axway-devops/"
              %li.resource-list-item
                %h4.resource-title
                  = link_to "How GitLab CI supported Ticketmaster's ramp up to weekly mobile releases", "/blog/2017/06/07/continous-integration-ticketmaster/"
